local BlkUI = LibStub("AceAddon-3.0"):NewAddon("BlkUI", "AceConsole-3.0", "AceEvent-3.0")
local db, dbg

-- Default Options
local defaults = {
	global = {
		tags = {
			firsttime = false,
		},
	},
	char = {
		installation = {
			stage = 0,
		},
	},
}

function BlkUI:UPDATE_PENDING_MAIL()
	self:UnregisterEvent("UPDATE_PENDING_MAIL")
	CancelEmote()	-- Cancel Map Holding animation
end

function BlkUI:PLAYER_LOGIN()
	-- Check if Installation/Patch is necessary
	self:InstallProcedure()
end

function BlkUI:ADDON_LOADED(event, addon)
	if addon ~= "BlkUI" then return end
	
	-- Open before login to stop taint
	ToggleFrame(SpellBookFrame)
	PetJournal_LoadUI()
	
	-- Remove Interface Options cancel button because it = taint
	InterfaceOptionsFrameCancel:Hide()
	InterfaceOptionsFrameOkay:SetAllPoints(InterfaceOptionsFrameCancel)

	-- Make clicking cancel the same as clicking okay
	InterfaceOptionsFrameCancel:SetScript("OnClick", function()
		InterfaceOptionsFrameOkay:Click()
	end)
end

function BlkUI:OnInitialize()
	-- Initialize settings, options, slash commands
	self.db = LibStub("AceDB-3.0"):New("BlkUIDB", defaults, "BlkUI")
	dbc = self.db.char
	dbg = self.db.global
	
	-- Vars
	self.realm = GetRealmName()
	self.class = select(2, UnitClass("player"))
	self.name = UnitName("player")
	self.key = string.format("%s - %s", self.name, self.realm)
	
	-- Register events
	self:RegisterEvent("ADDON_LOADED")
	self:RegisterEvent("PLAYER_LOGIN")
	self:RegisterEvent("UPDATE_PENDING_MAIL")
	
	-- Chat Commands
	self:RegisterChatCommand("rl", function() ReloadUI() end)

	-- Synch user's settings
	if dbg.tags.firsttime then
		SetCVar("synchronizeSettings", 1)
		SetCVar("synchronizeConfig", 1)
		SetCVar("synchronizeBindings", 1)
		SetCVar("synchronizeMacros", 1)
	end
	
	-- Done
	print("BlkUI loaded.")
end