-- Author      :Anonymous. Author to be released at a later date, 
--				dependant on his wishes. Permission granted to "TehVoyager" 
--				of the Ownedcore Forums to distribute this beta version for testing
--				under the condition that this file NOT be made available outside
--				ownedcore, and that code from this project can NOT be used to make
--				other addons.
-- Create Date : 12/29/2012 12:59:04 AM
local DBMskin = LibStub("AceAddon-3.0"):NewAddon("DBMskin", "AceHook-3.0")
local buttonsize = 22
local normTex = "Interface\\AddOns\\DBMskin\\normTex2.tga"
local blankTex = "Interface\\BUTTONS\\WHITE8X8"
-- local font = "Fonts\\ARIALN.TTF"

function DBMskin:OnEnable()
	DBMskin:SecureHook(DBT, "CreateBar", "SkinBars")
	DBM_SavedOptions.Enabled=true
	DBT_SavedOptions["DBM"].Texture = "Interface\\AddOns\\DBMskin\\normTex2.tga"
	--DBT_SavedOptions["DBM"].BarYOffset = 14
end

function DBMskin:SkinBars(self)
	for bar in self:GetBarIterator() do
		if not bar.injected then
			DBMskin:ApplyStyle(bar)
		end
	end
end

function DBMskin:ApplyStyle(bar)
	local frame = bar.frame
	local tbar = _G[frame:GetName().."Bar"]
	local spark = _G[frame:GetName().."BarSpark"]
	local texture = _G[frame:GetName().."BarTexture"]
	local icon1 = _G[frame:GetName().."BarIcon1"]
	local icon2 = _G[frame:GetName().."BarIcon2"]
	local name = _G[frame:GetName().."BarName"]
	local timer = _G[frame:GetName().."BarTimer"]
						
	if not (icon1.overlay) then
		icon1.overlay = CreateFrame("Frame", "$parentIcon1Overlay", tbar)
		DBMskin:CreateBackdrop(icon1.overlay)
		icon1.overlay:SetSize(buttonsize - 4, buttonsize - 4)
		icon1.overlay:SetPoint("BOTTOMRIGHT", frame, "BOTTOMLEFT", -5, 2)
	end

	if not (icon2.overlay) then
		icon2.overlay = CreateFrame("Frame", "$parentIcon2Overlay", tbar)
		DBMskin:CreateBackdrop(icon2.overlay)
		icon2.overlay:SetSize(buttonsize - 4, buttonsize - 4)
		icon2.overlay:SetPoint("BOTTOMLEFT", frame, "BOTTOMRIGHT", 5, 2)				
	end

	if bar.color then
		tbar:SetStatusBarColor(bar.color.r, bar.color.g, bar.color.b)
	else
		tbar:SetStatusBarColor(bar.owner.options.StartColorR, bar.owner.options.StartColorG, bar.owner.options.StartColorB)
	end
						
	if bar.enlarged then 
		frame:SetWidth(bar.owner.options.HugeWidth)
	else 
		frame:SetWidth(bar.owner.options.Width)
	end
	if bar.enlarged then 
		tbar:SetWidth(bar.owner.options.HugeWidth) 
	else 
		tbar:SetWidth(bar.owner.options.Width) 
	end

	if not frame.styled then
		--frame:SetScale(1)
		--frame.SetScale=s.dummy
		frame:SetHeight(buttonsize/3)
		--frame:SetTemplate("Transparent")
		frame.styled=true
	end

	if not spark.killed then
		spark:SetAlpha(0)
		spark:SetTexture(nil)
		spark.killed=true
	end
			
	if not icon1.styled then
		icon1:SetTexCoord(0.08, 0.92, 0.08, 0.92)
		icon1:ClearAllPoints()
		icon1:SetPoint("TOPLEFT", icon1.overlay, 0, 0)
		icon1:SetPoint("BOTTOMRIGHT", icon1.overlay, 0, 0)
		icon1.styled=true
	end
						
	if not icon2.styled then
		icon2:SetTexCoord(0.08, 0.92, 0.08, 0.92)
		icon2:ClearAllPoints()
		icon2:SetPoint("TOPLEFT", icon2.overlay, 0, 0)
		icon2:SetPoint("BOTTOMRIGHT", icon2.overlay, 0, 0)
		icon2.styled=true
	end

	if not texture.styled then
		texture:SetTexture(normTex)
		texture.styled=true
	end
						
	if not tbar.styled then
		tbar:SetStatusBarTexture(normTex)
	
		if tbar:GetPoint() then
			tbar:ClearAllPoints()
		end
	
		tbar:SetPoint('TOPLEFT', frame, 'TOPLEFT', 2, -2)
		tbar:SetPoint('BOTTOMRIGHT', frame, 'BOTTOMRIGHT', -2, 2)
		tbar.styled=true
	end

	if not name.styled then
		name:ClearAllPoints()
		name:SetPoint("LEFT", frame, "LEFT", 4, 0)
		name:SetPoint("BOTTOMLEFT", frame, "TOPLEFT", 0, 4)
		name:SetWidth(165)
		name:SetHeight(8)
		--name:SetFont(font, 12, 'OUTLINE')
		name:SetJustifyH("LEFT")
		name:SetShadowColor(0, 0, 0, 0)
		--name.SetFont = E.noop
		name.styled=true
	end
						
	if not timer.styled then	
		timer:ClearAllPoints()
		timer:SetPoint("RIGHT", frame, "RIGHT", -4, 0)
		timer:SetPoint("BOTTOMRIGHT", frame, "TOPRIGHT", -1, 2)
		--timer:SetFont(font, 12, 'OUTLINE')
		timer:SetJustifyH("RIGHT")
		timer:SetShadowColor(0, 0, 0, 0)
		--timer.SetFont = E.noop
		timer.styled=true
	end

	if bar.owner.options.IconLeft then 
		icon1:Show() 
		icon1.overlay:Show() 
	else 
		icon1:Hide() 
		icon1.overlay:Hide() 
	end
	if bar.owner.options.IconRight then 
		icon2:Show() 
		icon2.overlay:Show() 
	else 
		icon2:Hide() 
		icon2.overlay:Hide() 
	end
	tbar:SetAlpha(1)
	frame:SetAlpha(1)
	texture:SetAlpha(1)
	frame:Show()
	bar:Update(0)
	bar.injected=true
end

function DBMskin:CreateBackdrop(f)
	local b = CreateFrame("Frame", nil, f)
	local anchor = b:GetParent()
	
	if b:GetPoint() then
		b:ClearAllPoints()
	end
	
	b:SetPoint('TOPLEFT', anchor, 'TOPLEFT', -2, 2)
	b:SetPoint('BOTTOMRIGHT', anchor, 'BOTTOMRIGHT', 2, -2)

	DBMskin:SetTemplate(b)

	if f:GetFrameLevel() - 1 >= 0 then
		b:SetFrameLevel(f:GetFrameLevel() - 1)
	else
		b:SetFrameLevel(0)
	end
	
	f.backdrop = b
end

function DBMskin:SetTemplate(f)
	f:SetBackdrop({
		bgFile = blankTex, 
		edgeFile = blankTex, 
		tile = false, tileSize = 0, edgeSize = 1, 
		insets = { left = -1, right = -1, top = -1, bottom = -1 }
	})

	local backdropTexture = f:CreateTexture(nil, "BORDER")
	backdropTexture:SetDrawLayer("BACKGROUND", 1)
	f.backdropTexture = backdropTexture
	
	f:SetBackdropColor(0, 0, 0, 1)
	f.backdropTexture:SetVertexColor(0.1, 0.1, 0.1)
	f.backdropTexture:SetAlpha(1)
	f.backdropTexture:SetTexture(blankTex)
	
	if f:GetPoint() then
		f:ClearAllPoints()
	end
	
	f.backdropTexture:SetPoint('TOPLEFT', f.backdropTexture:GetParent(), 'TOPLEFT', 2, -2)
	f.backdropTexture:SetPoint('BOTTOMRIGHT', f.backdropTexture:GetParent(), 'BOTTOMRIGHT', -2, 2)
		
	f:SetBackdropBorderColor(0.1, 0.1, 0.1)
end